Object.defineProperty(exports, "__esModule", { value: true });
const fluent_1 = require("@berun/fluent");
class PluginPreset extends fluent_1.OrderableMap {
    constructor(parent, name, options = {}) {
        super(parent, name);
        this.options = fluent_1.FluentValue();
        this.extendfluent();
        this.options(options);
    }
    merge(obj, omit = []) {
        if (!obj) {
            return this;
        }
        if (Array.isArray(obj)) {
            this.set('options', obj[1]);
        }
        else {
            this.set('options', {});
        }
        return super.merge(obj, [...omit, 'options', 'name']);
    }
    toConfig() {
        const options = this.get('options');
        if (Object.keys(options).length === 0) {
            return this.name;
        }
        return [this.name, options];
    }
}
exports.PluginPreset = PluginPreset;
